/*
 * Routines to analyze command-line option < option.c >
 *
 * ޥɥ饤󥪥ץϤΤΥ롼
 *
 * Copyright (C) 1996,1997,1999 Taiji Yamada
 */
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int scan_option(int argc, char *argv[], char *key, ...)
{
  int i, n;
  char opt[1024], fmt[1024], *ptr;
  va_list argptr;
#ifndef ENABLE_VSSCANF
#define VLIST1(V) V[0]
#define VLIST2(V) V[0],V[1]
#define VLIST3(V) V[0],V[1],V[2]
#define VLIST4(V) V[0],V[1],V[2],V[3]
#define VLIST5(V) V[0],V[1],V[2],V[3],V[4]
#define VLIST6(V) V[0],V[1],V[2],V[3],V[4],V[5]
#define VLIST7(V) V[0],V[1],V[2],V[3],V[4],V[5],V[6]
#define VLIST8(V) V[0],V[1],V[2],V[3],V[4],V[5],V[6],V[7]
#define VLIST9(V) V[0],V[1],V[2],V[3],V[4],V[5],V[6],V[7],V[8]
#define VLIST10(V) V[0],V[1],V[2],V[3],V[4],V[5],V[6],V[7],V[8],V[9]
  int c;
  void **var;
#endif
  
  strcpy(opt, key);
  /*
   * scanf style option and its variations
   */
  if ((ptr=strchr(opt,'%')) != NULL) {
    int idx = 0;
    char *p, buf[1024];

    if ((p=strstr(opt,"\"%s\"")) != NULL) ptr = p;
    strcpy(fmt, ptr);
    *ptr = '\0';
    n = 0; while (*--ptr==' ') { *ptr = '\0'; n++; }
#ifndef ENABLE_VSSCANF
    c = 0;
    ptr = strchr(fmt, '%');
    while (ptr != NULL) {
      c++; if (c >= 10) break;
      ptr = strchr(ptr+1, '%');
    }
    var = (void **)malloc((c+1)*sizeof(void *));
    va_start(argptr, key);
    for (i=0; i<c; i++) var[i] = va_arg(argptr, void *);
    var[i] = NULL;
    va_end(argptr);
#endif
    for (i=1; i<argc; i++)
      if (strcmp(argv[i], opt)==0) {
        idx = i;
        /*
         * double quoted string option such as '-interp \"%s\"',
         * use like '-interp \"ghostview -\"'.
         */
        if ((ptr=strstr(key,"\"%s\"")) != NULL
            && strlen(opt)+n == (int)(ptr-key)) {
          if (idx+1 < argc && argv[idx+1][0] == '\"') {
            strcpy(buf, "");
            strcat(buf, argv[++i]+1);
            strcat(buf, " ");
            while (++i < argc) {
              strcat(buf, argv[i]);
              if ((ptr=strchr(buf,'\"')) != NULL) {
                *ptr = '\0';
                break;
              }
              if (i != argc-1) strcat(buf, " ");
            }
            va_start(argptr, key);
            strcpy(va_arg(argptr,void *), buf);
            va_end(argptr);
          } else {
            va_start(argptr, key);
            strcpy(va_arg(argptr,void *), argv[idx+1]);
            va_end(argptr);
          }
        }
        /*
         * option including some spaces such as "-title %s",
         * use like '-title "Title of this program"'.
         */
        else if (*((ptr=strchr(key,'%'))+1) == 's' && *(ptr+2) == '\0'
                 && strlen(opt)+n == (int)(ptr-key)) {
          va_start(argptr, key);
          strcpy(va_arg(argptr,void *), argv[idx+1]);
          va_end(argptr);
        }
        /*
         * normal scanf style options such "-geometry %dx%d",
         * use like "-geometry 640x480".
         */
        else {
          strcpy(buf, "");
          while (++i < argc) {
            strcat(buf, argv[i]);
            strcat(buf, " ");
          }
#ifdef ENABLE_VSSCANF
          va_start(argptr, key);
          vsscanf(buf, fmt, argptr);
          va_end(argptr);
#else
          switch (c) {
          case 1: sscanf(buf, fmt, VLIST1(var)); break;
          case 2: sscanf(buf, fmt, VLIST2(var)); break;
          case 3: sscanf(buf, fmt, VLIST3(var)); break;
          case 4: sscanf(buf, fmt, VLIST4(var)); break;
          case 5: sscanf(buf, fmt, VLIST5(var)); break;
          case 6: sscanf(buf, fmt, VLIST6(var)); break;
          case 7: sscanf(buf, fmt, VLIST7(var)); break;
          case 8: sscanf(buf, fmt, VLIST8(var)); break;
          case 9: sscanf(buf, fmt, VLIST9(var)); break;
          case 10: sscanf(buf, fmt, VLIST10(var)); break;
          }
#endif
        }
        break;
      }
#ifndef ENABLE_VSSCANF
    free(var);
#undef VLIST1
#undef VLIST2
#undef VLIST3
#undef VLIST4
#undef VLIST5
#undef VLIST6
#undef VLIST7
#undef VLIST8
#undef VLIST9
#undef VLIST10
#endif
    return idx;
  }
  /*
   * flag type option such as "[-+]on" or "[+-]on", use like "-on" or "+on".
   * "[-+]" style gives "-on": !0 and "+on": 0, and
   * "[+-]" style gives "+on": !0 and "-on": 0.
   */
  else if ((ptr=strstr(opt,"[-+]")) != NULL||
           (ptr=strstr(opt,"[+-]")) != NULL) {
    int *p;
    char buf[1024];
    
    va_start(argptr, key);
    p = (int *)va_arg(argptr, int *);
    va_end(argptr);
    strcpy(buf, (*(ptr+1)=='-')?"-":"+");
    strcat(buf, opt+strlen("[-+]"));
    for (i=1; i<argc; i++) {
      if (strcmp(argv[i], buf)==0) {
        *p = !0;
        return i; /* ! */
      }
    }
    strcpy(buf, (*(ptr+1)=='-')?"+":"-");
    strcat(buf, opt+strlen("[-+]"));
    for (i=1; i<argc; i++) {
      if (strcmp(argv[i], buf)==0) {
        *p = 0;
        return i; /* ! */
      }
    }
    return 0;
  }
  /*
   * flag type option such as "-on[-]", use like "-on": !0 or "-on-": 0.
   */
  else if ((ptr=strstr(opt,"[-]")) != NULL) {
    int *p;
    char buf[1024];

    *ptr = '\0';
    va_start(argptr, key);
    p = (int *)va_arg(argptr, int *);
    va_end(argptr);
    strcpy(buf, opt);
    for (i=1; i<argc; i++) {
      if (strcmp(argv[i], buf)==0) {
        *p = !0;
        return i; /* ! */
      }
    }
    strcat(buf, "-");
    for (i=1; i<argc; i++) {
      if (strcmp(argv[i], buf)==0) {
        *p = 0;
        return i; /* ! */
      }
    }
    return 0;
  }
  /*
   * enumerate type option such as "-color RED GREEN BLUE",
   * use like "-color RED" or "-color GREEN" or "-color BLUE".
   */
  else if ((ptr=strstr(opt," ")) != NULL) {
    int c, *p;

    va_start(argptr, key);
    p = (int *)va_arg(argptr, int *);
    va_end(argptr);
    c = 0;
    ptr = strtok(opt, " ");
    for (i=1; i<argc; i++)
      if (strcmp(argv[i], opt)==0) {
        ptr = strtok(NULL, " ");
        while (ptr && i+1<argc) {
          if (strcmp(argv[i+1], ptr)==0) {
            *p = c;
            return i; /* ! */
          }
          c++;
          ptr = strtok(NULL, " ");
        }
      }
  }
  /*
   * another style options such as "-help",
   * use like "-help" and 'if (scan_option(argc,argv,"-help")){...}' in C.
   */
  else {
    for (i=1; i<argc; i++)
      if (strcmp(argv[i], key)==0)
        return i;
    return 0;
  }
  return 0;
}
